#define _XOPEN_SOURCE (700)
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>

#include <errno.h>

#include <sys/inotify.h>
#include <limits.h>

#define checkError(expr,userMsg) \
    do { \
        if (!(expr)) {\
            perror(userMsg); \
            exit(EXIT_FAILURE); \
        } \
    } while (0)

#define MAX_SIZE (257)

int main(int argc, char** argv) {

    checkError(argc == 2, "...");

    int fd = open(argv[1], O_RDWR);
    checkError(fd != -1, "open");

    FILE* f = fdopen(fd, "r+");
    checkError(f != NULL, "...");

    char buffer[MAX_SIZE];
    while (fscanf(f, "%s", buffer) == 1) {

        char* err = NULL;
        int x = strotl(buffer, &err, 10);

        if (buffer[0] != 0 && *err == 0) {
            if (1000 <= x && x <= 9999) {

                struct flock lock;
                lock.l_type = F_WRLCK;
                lock.l_whence = SEEK_SET;
                lock.l_start = ftell(f);
                lock.l_len = -4; // -strlen(buffer);

                int retVal = fcntl(fd, F_SETLK, &lock);
                if (retVal == -1) {
                    if (errno != EACCES && errno != EAGAIN) {
                        checkError(0, "...");
                    }
                }
                else {
                    // -strlen(buffer);
                    checkError(fseek(f, -4, SEEK_CUR) != -1, "error");
                    fprintf(f, "xxxx");

                    lock.l_type = F_UNLCK;
                    checkError(fcntl(fd, F_SETLK, &lock), "...");
                }
            }
        }
    }

    fclose(f);

    exit(EXIT_SUCCESS);
}